Codeforces Round #284 (Div. 2) D. Name That Tune 概率dp

来源:互联网 发布:百度seo一本通pdf下载 编辑:程序博客网 时间:2024/05/16 11:00
D. Name That Tune
time limit per test
 1 second
memory limit per test
 256 megabytes
input
 standard input
output
 standard output

It turns out that you are a great fan of rock band AC/PE. Peter learned that and started the following game: he plays the first song of the list of n songs of the group, and you have to find out the name of the song. After you tell the song name, Peter immediately plays the following song in order, and so on.

The i-th song of AC/PE has its recognizability pi. This means that if the song has not yet been recognized by you, you listen to it for exactly one more second and with probability of pi percent you recognize it and tell it's name. Otherwise you continue listening it. Note that you can only try to guess it only when it is integer number of seconds after the moment the song starts playing.

In all AC/PE songs the first words of chorus are the same as the title, so when you've heard the first ti seconds of i-th song and its chorus starts, you immediately guess its name for sure.

For example, in the song Highway To Red the chorus sounds pretty late, but the song has high recognizability. In the song Back In Blue, on the other hand, the words from the title sound close to the beginning of the song, but it's hard to name it before hearing those words. You can name both of these songs during a few more first seconds.

Determine the expected number songs of you will recognize if the game lasts for exactly T seconds (i. e. you can make the last guess on the second T, after that the game stops).

If all songs are recognized faster than in T seconds, the game stops after the last song is recognized.

Input

The first line of the input contains numbers n and T (1 ≤ n ≤ 50001 ≤ T ≤ 5000), separated by a space. Next n lines contain pairs of numbers pi and ti (0 ≤ pi ≤ 1001 ≤ ti ≤ T). The songs are given in the same order as in Petya's list.

Output

Output a single number — the expected number of the number of songs you will recognize in T seconds. Your answer will be considered correct if its absolute or relative error does not exceed 10 - 6.

Sample test(s)
input
2 250 210 1
output
1.500000000
input
2 20 2100 2
output
1.000000000
input
3 350 350 225 2
output
1.687500000
input
2 20 20 2
output
1.000000000
题意,给出n首歌,与总时间,每首歌每秒有p[i]的概率听出,当达到t[i]时,一定可以听出。问能听几首歌的期望。

很好概率dp题,设dp[i][j]表示,第i首歌恰好在第j秒听出的概率。那么明显答案就是所有的dp[i][j]之和,因为,每个dp[i][j]都会使听的歌数多一首。

那么状态转移方程就是从

sum(dp[i-1][j - k] * p[i] ^ (k-1) * (1 - p[i])) p[i]表示第i首听不出概率。这个公式也就是从听出i-1 再过k秒听不出i这首歌。

可以发现,状态有 n * m 个,转移有t[i]个,所以总的复杂度达到n * m * m ,这是不可接受的。


我们比较公式,可以发现,dp[i][j] 与dp[i][j-1]之间是有关系的,dp[i][j]就是从dp[i][j-1] 减去最后一项,再* p[i] 再新加上从dp[i][j-1]转移到dp[i][j]的概率,所以,直接从dp[i][j-1]推出dp[i][j]复杂度降为o(n * m );


#define N 5005#define M 100005#define maxn 205#define MOD 1000000000000000007int n,m,t[N],a;double dp[N][N],p[N],ans;int main(){    //freopen("in.txt", "r", stdin);    //freopen("out.txt", "w", stdout);     while(S2(n,m)!=EOF)    {        FI(n+1){            FJ(m+1){                dp[i][j] = 0;            }        }        For(i,1,n+1){           S2(a,t[i]);           p[i] = 1.0 - (double)a / 100.0;        }        dp[0][0] = 1.0;ans = 0;        For(i,1,n+1){            double po = 1.0;            po = pow(p[i],t[i] - 1);            For(j,1,m+1){                double s = dp[i][j-1] ;                if(j - 1 >= t[i]) s -= dp[i-1][j-1-t[i]] * po;                s *= p[i];                if(j >= t[i]) {                    s += dp[i-1][j-t[i]] * po * p[i];                }                s += dp[i-1][j-1] * (1.0 - p[i]);                dp[i][j] = s;                ans += dp[i][j];            }        }        printf("%.10f\n",ans);    }    //fclose(stdin);    //fclose(stdout);    return 0;}



#define N 5005#define M 100005#define maxn 205#define MOD 1000000000000000007int n,m,t[N],a,flag;double dp[2][N],p[N],ans;int main(){    //freopen("in.txt", "r", stdin);    //freopen("out.txt", "w", stdout);     while(S2(n,m)!=EOF)    {        flag = 0;        FJ(m+1){            dp[0][j] = dp[1][j] = 0;        }        For(i,1,n+1){           S2(a,t[i]);           p[i] = 1.0 - (double)a / 100.0;        }        dp[flag][0] = 1.0;ans = 0;        For(i,1,n+1){            double po = 1.0;            po = pow(p[i],t[i] - 1);            int now = flag ^ 1,last = flag;            For(j,1,m+1){                double s = dp[now][j-1];                if(j - 1 >= t[i]) s -= dp[last][j-1-t[i]] * po;                s *= p[i];                if(j >= t[i]) {                    s += dp[last][j-t[i]] * po * p[i];                }                s += dp[last][j-1] * (1.0 - p[i]);                dp[now][j] = s;                ans += dp[now][j];            }            dp[flag][0] = 0;            flag ^= 1;        }        printf("%.10f\n",ans);    }    //fclose(stdin);    //fclose(stdout);    return 0;}



阅读全文
0 0
原创粉丝点击